<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSExtensibleLevel ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSExtensibleLevel extends AbstractStructArrayBase
{
    /**
     * The WSExtensibleLevel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSExtensibleLevel[]
     */
    public $WSExtensibleLevel;
    /**
     * Constructor method for ArrayOfWSExtensibleLevel
     * @uses ArrayOfWSExtensibleLevel::setWSExtensibleLevel()
     * @param \StructType\WSExtensibleLevel[] $wSExtensibleLevel
     */
    public function __construct(array $wSExtensibleLevel = array())
    {
        $this
            ->setWSExtensibleLevel($wSExtensibleLevel);
    }
    /**
     * Get WSExtensibleLevel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSExtensibleLevel[]|null
     */
    public function getWSExtensibleLevel()
    {
        return isset($this->WSExtensibleLevel) ? $this->WSExtensibleLevel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSExtensibleLevel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSExtensibleLevel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSExtensibleLevelForArrayConstraintsFromSetWSExtensibleLevel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSExtensibleLevelWSExtensibleLevelItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSExtensibleLevelWSExtensibleLevelItem instanceof \StructType\WSExtensibleLevel) {
                $invalidValues[] = is_object($arrayOfWSExtensibleLevelWSExtensibleLevelItem) ? get_class($arrayOfWSExtensibleLevelWSExtensibleLevelItem) : sprintf('%s(%s)', gettype($arrayOfWSExtensibleLevelWSExtensibleLevelItem), var_export($arrayOfWSExtensibleLevelWSExtensibleLevelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSExtensibleLevel property can only contain items of type \StructType\WSExtensibleLevel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSExtensibleLevel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSExtensibleLevel[] $wSExtensibleLevel
     * @return \ArrayType\ArrayOfWSExtensibleLevel
     */
    public function setWSExtensibleLevel(array $wSExtensibleLevel = array())
    {
        // validation for constraint: array
        if ('' !== ($wSExtensibleLevelArrayErrorMessage = self::validateWSExtensibleLevelForArrayConstraintsFromSetWSExtensibleLevel($wSExtensibleLevel))) {
            throw new \InvalidArgumentException($wSExtensibleLevelArrayErrorMessage, __LINE__);
        }
        if (is_null($wSExtensibleLevel) || (is_array($wSExtensibleLevel) && empty($wSExtensibleLevel))) {
            unset($this->WSExtensibleLevel);
        } else {
            $this->WSExtensibleLevel = $wSExtensibleLevel;
        }
        return $this;
    }
    /**
     * Add item to WSExtensibleLevel value
     * @throws \InvalidArgumentException
     * @param \StructType\WSExtensibleLevel $item
     * @return \ArrayType\ArrayOfWSExtensibleLevel
     */
    public function addToWSExtensibleLevel(\StructType\WSExtensibleLevel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSExtensibleLevel) {
            throw new \InvalidArgumentException(sprintf('The WSExtensibleLevel property can only contain items of type \StructType\WSExtensibleLevel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSExtensibleLevel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSExtensibleLevel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSExtensibleLevel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSExtensibleLevel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSExtensibleLevel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSExtensibleLevel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSExtensibleLevel
     */
    public function getAttributeName()
    {
        return 'WSExtensibleLevel';
    }
}
