<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSLevelModification ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSLevelModification extends AbstractStructArrayBase
{
    /**
     * The WSLevelModification
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSLevelModification[]
     */
    public $WSLevelModification;
    /**
     * Constructor method for ArrayOfWSLevelModification
     * @uses ArrayOfWSLevelModification::setWSLevelModification()
     * @param \StructType\WSLevelModification[] $wSLevelModification
     */
    public function __construct(array $wSLevelModification = array())
    {
        $this
            ->setWSLevelModification($wSLevelModification);
    }
    /**
     * Get WSLevelModification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSLevelModification[]|null
     */
    public function getWSLevelModification()
    {
        return isset($this->WSLevelModification) ? $this->WSLevelModification : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSLevelModification method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSLevelModification method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSLevelModificationForArrayConstraintsFromSetWSLevelModification(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSLevelModificationWSLevelModificationItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSLevelModificationWSLevelModificationItem instanceof \StructType\WSLevelModification) {
                $invalidValues[] = is_object($arrayOfWSLevelModificationWSLevelModificationItem) ? get_class($arrayOfWSLevelModificationWSLevelModificationItem) : sprintf('%s(%s)', gettype($arrayOfWSLevelModificationWSLevelModificationItem), var_export($arrayOfWSLevelModificationWSLevelModificationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSLevelModification property can only contain items of type \StructType\WSLevelModification, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSLevelModification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSLevelModification[] $wSLevelModification
     * @return \ArrayType\ArrayOfWSLevelModification
     */
    public function setWSLevelModification(array $wSLevelModification = array())
    {
        // validation for constraint: array
        if ('' !== ($wSLevelModificationArrayErrorMessage = self::validateWSLevelModificationForArrayConstraintsFromSetWSLevelModification($wSLevelModification))) {
            throw new \InvalidArgumentException($wSLevelModificationArrayErrorMessage, __LINE__);
        }
        if (is_null($wSLevelModification) || (is_array($wSLevelModification) && empty($wSLevelModification))) {
            unset($this->WSLevelModification);
        } else {
            $this->WSLevelModification = $wSLevelModification;
        }
        return $this;
    }
    /**
     * Add item to WSLevelModification value
     * @throws \InvalidArgumentException
     * @param \StructType\WSLevelModification $item
     * @return \ArrayType\ArrayOfWSLevelModification
     */
    public function addToWSLevelModification(\StructType\WSLevelModification $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSLevelModification) {
            throw new \InvalidArgumentException(sprintf('The WSLevelModification property can only contain items of type \StructType\WSLevelModification, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSLevelModification[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSLevelModification|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSLevelModification|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSLevelModification|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSLevelModification|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSLevelModification|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSLevelModification
     */
    public function getAttributeName()
    {
        return 'WSLevelModification';
    }
}
