<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSTerminalBooking ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSTerminalBooking extends AbstractStructArrayBase
{
    /**
     * The WSTerminalBooking
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSTerminalBooking[]
     */
    public $WSTerminalBooking;
    /**
     * Constructor method for ArrayOfWSTerminalBooking
     * @uses ArrayOfWSTerminalBooking::setWSTerminalBooking()
     * @param \StructType\WSTerminalBooking[] $wSTerminalBooking
     */
    public function __construct(array $wSTerminalBooking = array())
    {
        $this
            ->setWSTerminalBooking($wSTerminalBooking);
    }
    /**
     * Get WSTerminalBooking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSTerminalBooking[]|null
     */
    public function getWSTerminalBooking()
    {
        return isset($this->WSTerminalBooking) ? $this->WSTerminalBooking : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSTerminalBooking method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSTerminalBooking method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSTerminalBookingForArrayConstraintsFromSetWSTerminalBooking(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSTerminalBookingWSTerminalBookingItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSTerminalBookingWSTerminalBookingItem instanceof \StructType\WSTerminalBooking) {
                $invalidValues[] = is_object($arrayOfWSTerminalBookingWSTerminalBookingItem) ? get_class($arrayOfWSTerminalBookingWSTerminalBookingItem) : sprintf('%s(%s)', gettype($arrayOfWSTerminalBookingWSTerminalBookingItem), var_export($arrayOfWSTerminalBookingWSTerminalBookingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSTerminalBooking property can only contain items of type \StructType\WSTerminalBooking, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSTerminalBooking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSTerminalBooking[] $wSTerminalBooking
     * @return \ArrayType\ArrayOfWSTerminalBooking
     */
    public function setWSTerminalBooking(array $wSTerminalBooking = array())
    {
        // validation for constraint: array
        if ('' !== ($wSTerminalBookingArrayErrorMessage = self::validateWSTerminalBookingForArrayConstraintsFromSetWSTerminalBooking($wSTerminalBooking))) {
            throw new \InvalidArgumentException($wSTerminalBookingArrayErrorMessage, __LINE__);
        }
        if (is_null($wSTerminalBooking) || (is_array($wSTerminalBooking) && empty($wSTerminalBooking))) {
            unset($this->WSTerminalBooking);
        } else {
            $this->WSTerminalBooking = $wSTerminalBooking;
        }
        return $this;
    }
    /**
     * Add item to WSTerminalBooking value
     * @throws \InvalidArgumentException
     * @param \StructType\WSTerminalBooking $item
     * @return \ArrayType\ArrayOfWSTerminalBooking
     */
    public function addToWSTerminalBooking(\StructType\WSTerminalBooking $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSTerminalBooking) {
            throw new \InvalidArgumentException(sprintf('The WSTerminalBooking property can only contain items of type \StructType\WSTerminalBooking, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSTerminalBooking[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSTerminalBooking|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSTerminalBooking|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSTerminalBooking|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSTerminalBooking|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSTerminalBooking|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSTerminalBooking
     */
    public function getAttributeName()
    {
        return 'WSTerminalBooking';
    }
}
