<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WSTaskSearchParams StructType
 * @subpackage Structs
 */
class WSTaskSearchParams extends AbstractStructBase
{
    /**
     * The ageCutOff
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSTimestamp
     */
    public $ageCutOff;
    /**
     * The recipients
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSLink
     */
    public $recipients;
    /**
     * The searchFlags
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSKeyValue
     */
    public $searchFlags;
    /**
     * Constructor method for WSTaskSearchParams
     * @uses WSTaskSearchParams::setAgeCutOff()
     * @uses WSTaskSearchParams::setRecipients()
     * @uses WSTaskSearchParams::setSearchFlags()
     * @param \StructType\WSTimestamp $ageCutOff
     * @param \ArrayType\ArrayOfWSLink $recipients
     * @param \ArrayType\ArrayOfWSKeyValue $searchFlags
     */
    public function __construct(\StructType\WSTimestamp $ageCutOff = null, \ArrayType\ArrayOfWSLink $recipients = null, \ArrayType\ArrayOfWSKeyValue $searchFlags = null)
    {
        $this
            ->setAgeCutOff($ageCutOff)
            ->setRecipients($recipients)
            ->setSearchFlags($searchFlags);
    }
    /**
     * Get ageCutOff value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSTimestamp|null
     */
    public function getAgeCutOff()
    {
        return isset($this->ageCutOff) ? $this->ageCutOff : null;
    }
    /**
     * Set ageCutOff value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WSTimestamp $ageCutOff
     * @return \StructType\WSTaskSearchParams
     */
    public function setAgeCutOff(\StructType\WSTimestamp $ageCutOff = null)
    {
        if (is_null($ageCutOff) || (is_array($ageCutOff) && empty($ageCutOff))) {
            unset($this->ageCutOff);
        } else {
            $this->ageCutOff = $ageCutOff;
        }
        return $this;
    }
    /**
     * Get recipients value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSLink|null
     */
    public function getRecipients()
    {
        return isset($this->recipients) ? $this->recipients : null;
    }
    /**
     * Set recipients value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSLink $recipients
     * @return \StructType\WSTaskSearchParams
     */
    public function setRecipients(\ArrayType\ArrayOfWSLink $recipients = null)
    {
        if (is_null($recipients) || (is_array($recipients) && empty($recipients))) {
            unset($this->recipients);
        } else {
            $this->recipients = $recipients;
        }
        return $this;
    }
    /**
     * Get searchFlags value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSKeyValue|null
     */
    public function getSearchFlags()
    {
        return isset($this->searchFlags) ? $this->searchFlags : null;
    }
    /**
     * Set searchFlags value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSKeyValue $searchFlags
     * @return \StructType\WSTaskSearchParams
     */
    public function setSearchFlags(\ArrayType\ArrayOfWSKeyValue $searchFlags = null)
    {
        if (is_null($searchFlags) || (is_array($searchFlags) && empty($searchFlags))) {
            unset($this->searchFlags);
        } else {
            $this->searchFlags = $searchFlags;
        }
        return $this;
    }
}
